#ifndef _FTGR_PICTURES_H
#define _FTGR_PICTURES_H

#include	"types.h"
#include	"containe.h"

//Definition of errors while Loading/Saving File(s)
#define ErrOK		  0
#define ErrOpenFile	 -1
#define ErrReadFile	 -2
#define ErrWriteFile	 -3
#define ErrBadFileFormat -4

#define ErrNoMem	-10

typedef struct
      {
      BYTE r;
      BYTE g;
      BYTE b;
      } RGB;
#define GetR(RGB) (((DWORD)(RGB) >> 8) & 0xFF)
#define GetG(RGB) (((DWORD)(RGB) >>16) & 0xFF)
#define GetB(RGB) (((DWORD)(RGB) >>24) & 0xFF)

#define NOTHING 0
#define FILL 1


typedef union
        {
        void  *v;
        BYTE  *b;
        WORD  *w;
        DWORD *d;
	} LinePict;


class TPalette:public container1D
	{
public: char &Red(int i);
	char &Green(int i);
	char &Blue(int i);

	int Size(void)	  {return size1D;};
	int Colors(void)  {return size1D/3;};
	int GrayPalette(void);		//Is this Gray scale palette?
	};


class Image:container2D
	{
	int sizex;

public: char     typ;
	char     planes;

	int      SizeX(void)	{return(sizex);};
	int      SizeY(void)	{return(size2D);};

	LinePict *LinePtr(void) {return((LinePict *)data2D);}

	TPalette palette;


	void CreatePalette(int type=0);

        Image(void);
        Image(Image &);
        ~Image(void);
	int Create(int x, int y, int NewPlanes, int Option=FILL);
        void Erase(void);
	int Valid(void);
	int LineSize(void);
	void FormR(int y, WORD *FData);
	void RfrmB(int y, WORD *FData);

	void SetPixel(int x, int y,long value);
	long GetPixel(int x, int y);

        Image & operator=(Image &);
	};


inline int Image::Valid(void)
{ return(data2D!=NULL); }

inline int Image::LineSize(void)
{
 return ((planes+7)/8)*SizeX();
};


void Peel1Plane(Image & p, int y,short plane,void *ukbity);
void PeelPlane(Image & obr,Image & PlaneX,int PlaneNum);
void Join1Plane(Image &p,unsigned y,char plane,void *ukbity);
void JoinPlane(Image & PlaneX,Image & Obr, BYTE PlaneNum);

extern void Canny( Image &im_in, Image &im_out, float disp, float scale );


int SavePicture(char *Name,Image & p);

int LoadPicture(char *Name,Image & p);



int SavePictureBMP(const char *Name,Image & p);

int LoadPictureBMP(const char *Name,Image & p);

#endif /* _FTGR_PICTURES_H */
